diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-reception-test.cc ns-3.43/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-reception-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-reception-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -2148,16 +2138,11 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should not be
     // aborted since L-SIG can be decoded (SNR high enough).
 
-    Simulator::Schedule(Seconds(2.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(2.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3,
+                        rxPower - 3,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2199,16 +2184,11 @@
     // the start of HE-SIG of the first packet: PHY header reception should not succeed but PHY
     // should stay in RX state for the duration estimated from L-SIG.
 
-    Simulator::Schedule(Seconds(3.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(3.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000,
                         7);
     // At 44us (end of PHY header), STA PHY STATE should not have moved to RX (HE-SIG failed) and be
@@ -2240,16 +2220,11 @@
     // CASE 4: send one packet followed by a second one 3 dB weaker between the end of L-SIG and the
     // start of HE-SIG of the first packet: PHY header reception should succeed.
 
-    Simulator::Schedule(Seconds(4.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(4.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3,
+                        rxPower - 3,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2288,22 +2263,17 @@
                         WifiPhyState::IDLE);
 
     // RX power < CCA-ED
-    rxPowerDbm = -70;
+    rxPower = -70;
 
     // CASE 5: send one packet followed by a second one with same power between the end of the 4us
     // preamble detection window and the start of L-SIG of the first packet: reception should be
     // aborted since L-SIG cannot be decoded (SNR too low).
 
-    Simulator::Schedule(Seconds(5.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(5.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2322,16 +2292,11 @@
     // preamble detection window and the start of L-SIG of the first packet: reception should not be
     // aborted since L-SIG can be decoded (SNR high enough).
 
-    Simulator::Schedule(Seconds(6.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(6.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(10),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3,
+                        rxPower - 3,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2370,16 +2335,11 @@
     // the start of HE-SIG of the first packet: PHY header reception should not succeed but PHY
     // should stay in RX state for the duration estimated from L-SIG.
 
-    Simulator::Schedule(Seconds(7.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(7.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(7.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2409,16 +2369,11 @@
     // CASE 8: send one packet followed by a second one 3 dB weaker between the end of L-SIG and the
     // start of HE-SIG of the first packet: PHY header reception should succeed.
 
-    Simulator::Schedule(Seconds(8.0),
-                        &TestPhyHeadersReception::SendPacket,
-                        this,
-                        rxPowerDbm,
-                        1000,
-                        7);
+    Simulator::Schedule(Seconds(8.0), &TestPhyHeadersReception::SendPacket, this, rxPower, 1000, 7);
     Simulator::Schedule(Seconds(8.0) + MicroSeconds(25),
                         &TestPhyHeadersReception::SendPacket,
                         this,
-                        rxPowerDbm - 3,
+                        rxPower - 3,
                         1000,
                         7);
     // At 10 us, STA PHY STATE should be CCA_BUSY.
@@ -2513,11 +2468,11 @@
     /**
      * Send A-MPDU with 3 MPDUs of different size (i-th MSDU will have 100 bytes more than
      * (i-1)-th).
-     * \param rxPowerDbm the transmit power in dBm
+     * \param rxPower the transmit power
      * \param referencePacketSize the reference size of the packets in bytes (i-th MSDU will have
      * 100 bytes more than (i-1)-th)
      */
-    void SendAmpduWithThreeMpdus(double rxPowerDbm, uint32_t referencePacketSize);
+    void SendAmpduWithThreeMpdus(dBm_u rxPower, uint32_t referencePacketSize);
 
     /**
      * Check the RX success bitmap for A-MPDU 1
@@ -2771,10 +2726,17 @@
 }
 
 void
-TestAmpduReception::SendAmpduWithThreeMpdus(double rxPowerDbm, uint32_t referencePacketSize)
+TestAmpduReception::SendAmpduWithThreeMpdus(dBm_u rxPower, uint32_t referencePacketSize)
 {
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         true);
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -2796,7 +2758,7 @@
     Ptr<SpectrumValue> txPowerSpectrum =
         WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
                                                                     CHANNEL_WIDTH,
-                                                                    DbmToW(rxPowerDbm),
+                                                                    DbmToW(rxPower),
                                                                     GUARD_WIDTH);
 
     Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
@@ -2835,7 +2797,7 @@
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(2);
     int64_t streamNumber = 1;
-    double rxPowerDbm = -30;
+    dBm_u rxPower = -30;
     m_phy->AssignStreams(streamNumber);
 
     /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
@@ -2848,14 +2810,14 @@
     Simulator::Schedule(Seconds(1.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(1.0) + MicroSeconds(2),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been ignored.
@@ -2898,14 +2860,14 @@
     Simulator::Schedule(Seconds(2.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(2),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received.
@@ -2948,14 +2910,14 @@
     Simulator::Schedule(Seconds(3.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(3.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been ignored.
@@ -2998,14 +2960,14 @@
     Simulator::Schedule(Seconds(4.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(4.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received.
@@ -3048,14 +3010,14 @@
     Simulator::Schedule(Seconds(5.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(5.0) + MicroSeconds(100),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been ignored.
@@ -3098,14 +3060,14 @@
     Simulator::Schedule(Seconds(6.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(6.0) + MicroSeconds(100),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received.
@@ -3147,14 +3109,14 @@
     Simulator::Schedule(Seconds(7.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(7.0) + NanoSeconds(1100000),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been ignored.
@@ -3196,14 +3158,14 @@
     Simulator::Schedule(Seconds(8.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(8.0) + NanoSeconds(1100000),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm - 100,
+                        rxPower - 100,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received.
@@ -3246,14 +3208,14 @@
     Simulator::Schedule(Seconds(9.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(9.0) + MicroSeconds(2),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 3,
+                        rxPower + static_cast<dB_u>(3.0),
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been dropped.
@@ -3296,14 +3258,14 @@
     Simulator::Schedule(Seconds(10.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(10.0) + MicroSeconds(2),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been dropped (preamble detection failed).
@@ -3346,14 +3308,14 @@
     Simulator::Schedule(Seconds(11.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 3,
+                        rxPower + static_cast<dB_u>(3.0),
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(11.0) + MicroSeconds(2),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3396,14 +3358,14 @@
     Simulator::Schedule(Seconds(12.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(12.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 3,
+                        rxPower + static_cast<dB_u>(3.0),
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors (PHY header reception failed and
@@ -3448,14 +3410,14 @@
     Simulator::Schedule(Seconds(13.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(13.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors (PHY header reception failed and
@@ -3499,14 +3461,14 @@
     Simulator::Schedule(Seconds(14.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 3,
+                        rxPower + static_cast<dB_u>(3.0),
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(14.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3549,14 +3511,14 @@
     Simulator::Schedule(Seconds(15.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(15.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been dropped because PHY reception switched to A-MPDU 2.
@@ -3599,14 +3561,14 @@
     Simulator::Schedule(Seconds(16.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(16.0) + MicroSeconds(10),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been successfully received.
@@ -3649,14 +3611,14 @@
     Simulator::Schedule(Seconds(17.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(17.0) + MicroSeconds(25),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3700,14 +3662,14 @@
     Simulator::Schedule(Seconds(18.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(18.0) + MicroSeconds(25),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been successfully received.
@@ -3750,14 +3712,14 @@
     Simulator::Schedule(Seconds(19.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(19.0) + MicroSeconds(25),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3800,14 +3762,14 @@
     Simulator::Schedule(Seconds(20.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(20.0) + MicroSeconds(100),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3851,14 +3813,14 @@
     Simulator::Schedule(Seconds(21.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm + 6,
+                        rxPower + static_cast<dB_u>(6.0),
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(21.0) + MicroSeconds(100),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been successfully received.
@@ -3901,14 +3863,14 @@
     Simulator::Schedule(Seconds(22.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(22.0) + MicroSeconds(100),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // All MPDUs of A-MPDU 1 should have been received with errors.
@@ -3950,14 +3912,14 @@
     Simulator::Schedule(Seconds(23.0),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1000);
 
     // A-MPDU 2
     Simulator::Schedule(Seconds(23.0) + NanoSeconds(1100000),
                         &TestAmpduReception::SendAmpduWithThreeMpdus,
                         this,
-                        rxPowerDbm,
+                        rxPower,
                         1300);
 
     // The first MPDU of A-MPDU 1 should have been successfully received (no interference).
@@ -4129,7 +4091,7 @@
     }
 
     // Assign fixed streams to random variables in use
-    wifi.AssignStreams(m_apDevices, streamNumber);
+    WifiHelper::AssignStreams(m_apDevices, streamNumber);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
@@ -4225,10 +4187,10 @@
     /**
      * Function to create a PPDU
      *
-     * \param centerFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
-     * \param bandwidthMhz the bandwidth used for the transmission of the PPDU (in MHz)
+     * \param centerFreq the center frequency used for the transmission of the PPDU
+     * \param bandwidth the bandwidth used for the transmission of the PPDU
      */
-    void SendPpdu(uint16_t centerFreqMhz, uint16_t bandwidthMhz);
+    void SendPpdu(MHz_u centerFreq, MHz_u bandwidth);
 
     /**
      * Function called upon a PSDU received successfully
@@ -4298,10 +4260,17 @@
 }
 
 void
-TestUnsupportedBandwidthReception::SendPpdu(uint16_t centerFreqMhz, uint16_t bandwidthMhz)
+TestUnsupportedBandwidthReception::SendPpdu(MHz_u centerFreq, MHz_u bandwidth)
 {
-    auto txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, bandwidthMhz, false);
+    auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                 0,
+                                 WIFI_PREAMBLE_HE_SU,
+                                 NanoSeconds(800),
+                                 1,
+                                 1,
+                                 0,
+                                 bandwidth,
+                                 false);
 
     auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
@@ -4315,11 +4284,10 @@
 
     auto ppdu = Create<HePpdu>(psdu, txVector, m_txPhy->GetOperatingChannel(), txDuration, 0);
 
-    auto txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(centerFreqMhz,
-                                                                    bandwidthMhz,
-                                                                    DbmToW(-50),
-                                                                    bandwidthMhz);
+    auto txPowerSpectrum = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(centerFreq,
+                                                                                       bandwidth,
+                                                                                       DbmToW(-50),
+                                                                                       bandwidth);
 
     auto txParams = Create<WifiSpectrumSignalParameters>();
     txParams->psd = txPowerSpectrum;
@@ -4506,27 +4474,27 @@
     /**
      * Function to create a PPDU
      *
-     * \param ppduCenterFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
+     * \param ppduCenterFreq the center frequency used for the transmission of the PPDU
      * \return the created PPDU
      */
-    Ptr<HePpdu> CreatePpdu(uint16_t ppduCenterFreqMhz);
+    Ptr<HePpdu> CreatePpdu(MHz_u ppduCenterFreq);
 
     /**
      * Run one function
      *
      * \param band the PHY band to use
-     * \param phyCenterFreqMhz the operating center frequency of the PHY (in MHz)
+     * \param phyCenterFreq the operating center frequency of the PHY
      * \param p20Index the primary20 index
-     * \param ppduCenterFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
+     * \param ppduCenterFreq the center frequency used for the transmission of the PPDU
      * \param expectedP20Overlap flag whether the primary 20 MHz channel is expected to be fully
      * covered by the bandwidth of the incoming PPDU
      * \param expectedP20Covered flag whether the
      * primary 20 MHz channel is expected to overlap with the bandwidth of the incoming PPDU
      */
     void RunOne(WifiPhyBand band,
-                uint16_t phyCenterFreqMhz,
+                MHz_u phyCenterFreq,
                 uint8_t p20Index,
-                uint16_t ppduCenterFreqMhz,
+                MHz_u ppduCenterFreq,
                 bool expectedP20Overlap,
                 bool expectedP20Covered);
 
@@ -4541,23 +4509,30 @@
 }
 
 Ptr<HePpdu>
-TestPrimary20CoveredByPpdu::CreatePpdu(uint16_t ppduCenterFreqMhz)
+TestPrimary20CoveredByPpdu::CreatePpdu(MHz_u ppduCenterFreq)
 {
-    [[maybe_unused]] auto [channelNumber, centerFreq, channelWidth, type, phyBand] =
-        (*WifiPhyOperatingChannel::FindFirst(0,
-                                             ppduCenterFreqMhz,
-                                             0,
-                                             WIFI_STANDARD_80211ax,
-                                             m_rxPhy->GetPhyBand()));
-    m_txPhy->SetOperatingChannel(WifiPhy::ChannelTuple{channelNumber, channelWidth, phyBand, 0});
-    auto txVector =
-        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, channelWidth, false);
+    const auto& channelInfo = (*WifiPhyOperatingChannel::FindFirst(0,
+                                                                   ppduCenterFreq,
+                                                                   0,
+                                                                   WIFI_STANDARD_80211ax,
+                                                                   m_rxPhy->GetPhyBand()));
+    m_txPhy->SetOperatingChannel(
+        WifiPhy::ChannelTuple{channelInfo.number, channelInfo.width, channelInfo.band, 0});
+    auto txVector = WifiTxVector(HePhy::GetHeMcs7(),
+                                 0,
+                                 WIFI_PREAMBLE_HE_SU,
+                                 NanoSeconds(800),
+                                 1,
+                                 1,
+                                 0,
+                                 channelInfo.width,
+                                 false);
 
     auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr(WIFI_MAC_QOSDATA);
 
     auto psdu = Create<WifiPsdu>(pkt, hdr);
-    auto txDuration = m_txPhy->CalculateTxDuration(psdu->GetSize(), txVector, phyBand);
+    auto txDuration = m_txPhy->CalculateTxDuration(psdu->GetSize(), txVector, channelInfo.band);
 
     return Create<HePpdu>(psdu, txVector, m_txPhy->GetOperatingChannel(), txDuration, 0);
 }
@@ -4593,22 +4568,22 @@
 
 void
 TestPrimary20CoveredByPpdu::RunOne(WifiPhyBand band,
-                                   uint16_t phyCenterFreqMhz,
+                                   MHz_u phyCenterFreq,
                                    uint8_t p20Index,
-                                   uint16_t ppduCenterFreqMhz,
+                                   MHz_u ppduCenterFreq,
                                    bool expectedP20Overlap,
                                    bool expectedP20Covered)
 {
-    [[maybe_unused]] const auto [channelNumber, centerFreq, channelWidth, type, phyBand] =
-        (*WifiPhyOperatingChannel::FindFirst(0, phyCenterFreqMhz, 0, WIFI_STANDARD_80211ax, band));
+    const auto& channelInfo =
+        (*WifiPhyOperatingChannel::FindFirst(0, phyCenterFreq, 0, WIFI_STANDARD_80211ax, band));
 
     m_rxPhy->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNumber, channelWidth, band, p20Index});
+        WifiPhy::ChannelTuple{channelInfo.number, channelInfo.width, channelInfo.band, p20Index});
     auto p20CenterFreq = m_rxPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(20);
     auto p20MinFreq = p20CenterFreq - 10;
     auto p20MaxFreq = p20CenterFreq + 10;
 
-    auto ppdu = CreatePpdu(ppduCenterFreqMhz);
+    auto ppdu = CreatePpdu(ppduCenterFreq);
 
     auto p20Overlap = ppdu->DoesOverlapChannel(p20MinFreq, p20MaxFreq);
     NS_TEST_ASSERT_MSG_EQ(p20Overlap,
@@ -4696,7 +4671,7 @@
      * \param channel channel to be used by transmitter
      * \param expectedValue expected number of received packets
      */
-    TestSpectrumChannelWithBandwidthFilter(uint16_t channel, uint16_t expectedValue);
+    TestSpectrumChannelWithBandwidthFilter(uint8_t channel, uint16_t expectedValue);
 
   protected:
     void DoSetup() override;
